tic;clc;clear;
%c0:u0/2pi,I:Ȧ(A),I:Ȧ(m),R:Ȧ뾶(m)
c0=2e-7;I=1e6;L=2;R=1.0;
n=100; x1=0;x2=6*R;z1=-1.0; z2=1.0;
dx = (x2-x1)/n; dz = 2*(z2-z1)/n;
[x,z]=meshgrid(x1:dx:x2,3*z1:dz:3*z2);
k2_1=4*R*x./((R+x).^2+(z+L/2).^2);
k2_1=k2_1-eps*(k2_1==1);
k2_2=4*R*x./((R+x).^2+(z-L/2).^2);
k2_2=k2_2-eps*(k2_2==1);
[K1,E1]= ellipke(k2_1);
[K2,E2]=ellipke(k2_2);
dd1=(R-x).^2+(z+L/2).^2;
dd1=dd1+eps*(dd1==0);
dd2=(R-x).^2+(z-L/2).^2;
dd2=dd2+eps*(dd2==0);
%Ȧ1Ĵų
Bx1=c0*I*(z+L/2)./(x+eps*(x==0))./sqrt((R+x).^2+(z+L/2).^2).*((R^2+x.^2+(z+L/2).^2)./dd1.*E1-K1);
Bz1=c0*I./sqrt((R+x).^2+(z+L/2).^2).*((R^2-x.^2-(z+L/2).^2)./dd1.*E1+K1);
%Ȧ2Ĵų
Bx2=c0*I*(z-L/2)./(x+eps*(x==0))./sqrt((R+x).^2+(z-L/2).^2).*((R^2+x.^2+(z-L/2).^2)./dd2.*E2-K2);
Bz2=c0*I./sqrt((R+x).^2+(z-L/2).^2).*((R^2-x.^2-(z-L/2).^2)./dd2.*E2+K2);
Bx=Bx1+Bx2;
Bz=Bz1+Bz2;
vz =[0,1]; vx=[0:0.2:4*R];
[px,pz]=meshgrid(vx,vz);
streamline(x,z,Bx,Bz,px,pz);hold on;
streamline(x,-z,Bx,-Bz,px,-pz);
streamline(-x,z,-Bx,Bz,-px,pz);
streamline(-x,-z,-Bx,-Bz,-px,-pz);
plot([-R -R R R],[z1 z2 z1 z2],'r.','markersize',40);
plot([0 0],[3*z1 3*z2],'b-','linewidth',1);
xlabel('x');ylabel('z');set(gca,'FontSize',20);
disp(['ʱ' num2str(toc) 's']);
%д뵽ļ
time=datestr(now,30);
print(gcf,['Simple_Mirror_2D_',time,'.eps'],'-depsc','-r600')
savefig(['Simple_Mirror_2D_',time,'.fig'])
print(gcf,['Simple_Mirror_2D_',time,'.png'],'-dpng')
disp(['ʱ' num2str(toc) 's']);